# dirty , save, don't save , cancel quit
# should be called by controlling application
proc TodoQuit { } {
	global todo
#todo(fileIsDirty)
return 1
}

proc TodoLoad { myfile } {
	global todo vt
	

	set f [open $myfile r]
	set par /
	set lines {}
	set linecnt 0
	set catCnt 0
	set itemCnt 0
	set bogusList {}

	if { [todoValidVersion	$f ] } {
		return
	}
	if { ! $todo(merge) } { TodoInit }
	
	UiWaitAll disable cursor
	UiWaitAll disable state

	while { [gets $f line ]!= -1 } {	
		if { [regexp {^/} $line ] } {
# ADDING A CAT
		
			if { $line == "/" } {continue}
			catch { 
# may exist if merging
				set par [EntryFromCatData / [file dirname $line]]
				if { $par == {} } { 
					append bogusList $line
					puts bogusCatonLoadNoparentFound
				}
				set par [TodoInsert  cat $par]
				set txt [file tail $line]	
				NewEntryArray ltemp	
				EntryToArray  $par ltemp
				set ltemp(catData) $txt
				ArrayToEntryData $par ltemp
				EntryDisplayUpdate $par ltemp
				incr catCnt
			}
			
		} else {
		# ADDING AN ITEM		

			incr linecnt
			if { ![regexp {\}$} $line ] } {
# line not term w/ ""
				append lines $line\n				
				continue
			} else {
# line is term w/ ""			
				append lines $line
				set item [TodoInsert  item $par]
				NewEntryArray ltemp	
				array set ltemp $lines
				ArrayToEntryData $item ltemp
				EntryDisplayUpdate $item ltemp				
				set lines {}
				set linecnt  0
				incr itemCnt
			}
		}
	}
	close $f
	set todo(file) $myfile
	UiWaitAll enable cursor
	UiWaitAll enable state
	VtStatus "Loaded $catCnt cats & $itemCnt items"
	puts $bogusList
}



proc TodoSave {  } {
	global todo vt
	
	if { $todo(file) == {} } {
		VtStatus "No file selected"
		return
	}
	set todo(f) [open $todo(file) w]
	puts $todo(f) $vt(product,name) 
	puts $todo(f) $vt(product,version)
	puts $todo(f) todo

	puts $todo(f) /
	recSave / {}
	close $todo(f)
	VtStatus "Save $todo(file)"
}



# use parent path to construct name
proc recSave { node parentpath} {
	global todo
			set nodes [$todo(hlist) info children $node]
#			set nodes [lsort -command todosort $nodes ]
		 foreach x  $nodes {	
			set type [$todo(hlist) entrycget $x -image]
#			NewEntryArray ltemp	
			TodoGetEntryInfo  $x ltemp			
			if { ! [TodoIsItem $x] } {
				set path $parentpath/$ltemp(catData)
				puts $todo(f) $path
				recSave $x $path
			} else {
				puts $todo(f) [array get ltemp]
			}
		}
}
# use parent path to construct name
proc recSave { node parentpath} {
	global todo
			set nodes [$todo(hlist) info children $node]
#			set nodes [lsort -command todosort $nodes ]
		 foreach x  $nodes {	
			set type [$todo(hlist) entrycget $x -image]
#			NewEntryArray ltemp	
			TodoGetEntryInfo  $x ltemp			
			if { ! [TodoIsItem $x] } {
				set path $parentpath/$ltemp(catData)
				puts $todo(f) $path
				recSave $x $path
			} else {
				if { [TodoIsEntryDone $x ] } { 
					set ltemp(status) 1
				} else {
					set ltemp(status) 0
				}
				if { [TodoIsEntryFlagged $x ] } {
					set ltemp(flag) 1
				} else {
					set ltemp(flag) 0				
				}
				puts $todo(f) [array get ltemp]
			}
		}
}


# From fpath /a/b/c/d return autogenerated entry name 
# ex / /mycat/yourcat/itemXX
# non unique , finds 1st match
# RETURN HLIST ENTRY TIXID IF FOUND

proc EntryFromCatData { e fpath } {
	global todo
	regsub {^/} $fpath {} fpath
# GET CURRENT PATH FROM FPATH	
	set match [lindex [split $fpath /] 0]
# PEEL OFF PARENT PATH	
	set nfpath [join [lrange [split $fpath /] 1 end] /]
 foreach x  [$todo(hlist) info children $e] {	
				
				if { ! [TodoIsItem $x] } {
#					NewEntryArray ltemp	
					TodoGetEntryInfo  $x ltemp
					set data $ltemp(catData)	
					if { $match == "$data" } {
						if  { $nfpath == {} } {
							return $x					
						} else {
							return [EntryFromCatData  $x $nfpath]
						}						
					} 
				}
	}
	return {}
}


proc todoValidVersion { f } {
	global vt
	set product {} 
	set version {}
	set subproduct {}	
	catch {
		gets $f product
		gets $f version
		gets $f subproduct
	}
	if { $vt(product,name) != $product } {
		VtStatus "Not a todo file"
		close $f
		return 1
	}
	if { $subproduct != "todo" } {
		VtStatus "Not matching product "
		close $f
		return 1
	} 	
	if { $vt(product,version) != $version } {
		VtStatus "Not matching version "
		close $f
		return 1
	} 	
	return 0
}
